var EntryList;
var EntryDesc;
var cqrShowBlocked = false;

function init(){
  EntryList    = document.getElementById('EntryList');
  EntryDesc    = document.getElementById('Desc');
  cqrShowBlocked  = document.getElementById('showblocked').checked;
  plg_QuickLoadAll();
	window.setTimeout('initWithDelay();', 0);
  //window.sizeToContent();
}

function initWithDelay(){
  fillprefstab();
  initList(EntryList, EntryHash);
  window.sizeToContent();
}

function plg_ReloadTree(){
  plg_QuickLoadAll();
  initList(EntryList, EntryHash);
}

function plg_block(really){
  if (!EntryList.selectedItem) return;
  id = EntryList.selectedItem.getAttribute('value');
  EntryHash.Items[id].blocked = really;
  prfs_SaveEntry(EntryHash.Items[id]);
  if (really){
    EntryList.removeChild(EntryList.selectedItem);
  }else{
    EntryList.selectedItem.setAttribute('style', "color: #000000");
  }
}

function fillprefstab() {
	document.getElementById('prfs_plugsdir').value = cqrPlugsDir;
	document.getElementById('enhotmenu').checked = cqrUseHotMenu;
	document.getElementById('HTTPIcon').checked = cqrHTTPIcon;
	document.getElementById('hidefromtools').checked = cqrHideFromTools;
	document.getElementById('cspInMainMenu').checked = cqrShowCSPInMainMenu;
  document.getElementById('cqrHideQueryTo').checked = cqrHideQueryTo;
	document.getElementById('MainContextLimit').value = cqrMainContextLimit;


	switch (cqrOpenRes)
	{
		case 'tab_bg':
		    document.getElementById('open_res').selectedIndex = 0;
		    break;
		case 'tab_fg':
		    document.getElementById('open_res').selectedIndex = 1;
		    break;
		case 'win_bg':
		    document.getElementById('open_res').selectedIndex = 2;
		    break;
		case 'win_fg':
		    document.getElementById('open_res').selectedIndex = 3;
		    break;
	}
}



function initList(list, srcHash){
  cqrShowBlocked  = document.getElementById('showblocked').checked;
  while (list.hasChildNodes()) {list.removeChild(list.lastChild)}
  var ondk;
  var onsel;
  var item;
  var node;
  var celldata;
  var cellcheck;
  var entries = srcHash._Items();
  var listcols =  document.createElement('listcols');
  var listcol1 =  document.createElement('listcol');
  var listcol2 =  document.createElement('listcol');
  //var listcol3 =  document.createElement('listcol');
  var splitter = document.createElement('splitter');
  var listhead = document.createElement('listhead');
  var listheader1 =  document.createElement('listheader');
  var listheader2 =  document.createElement('listheader');
  //var listheader3 =  document.createElement('listheader');
  splitter.setAttribute("class", "tree-splitter");
  listcol1.setAttribute("flex", "1");
  listcol2.setAttribute("flex", "0");
  //listcol2.setAttribute("align", "center");
  //listcol2.setAttribute("style", "width: 4em;");
  //listcol3.setAttribute("flex", "1");
  //listcol3.setAttribute("style", "width: 5em;");
  listcols.appendChild(listcol1);
    if (srcHash.Items == EntryHash.Items){
      listcols.appendChild(splitter);
      listcols.appendChild(listcol2);
      //listcols.appendChild(listcol3);
    }
  listheader1.setAttribute('label', cqrMess.GetStringFromName('cqr.cfg.plgCol'));
  listheader2.setAttribute('label', cqrMess.GetStringFromName('cqr.cfg.showCol'));
  //listheader3.setAttribute('label', cqrMess.GetStringFromName('cqr.cfg.showIfCol'));
  listhead.appendChild(listheader1);
    if (srcHash.Items == EntryHash.Items){
      listhead.appendChild(listheader2);
      //listhead.appendChild(listheader3);
    }
  list.appendChild(listcols);
  list.appendChild(listhead);
  
  for (i in entries){
		if ((!cqrShowBlocked) && (entries[i].blocked)) continue;
  	ondk  = 'if (isValidLeftClick(event,"listitem")) ExecQuery(event.ctrlKey, "'+entries[i].eId+'");';
	  onsel = 'onSelect(EntryHash, EntryDesc, '+entries[i].eId+')'

    item = document.createElement('listitem');
    item.setAttribute('class', 'listitem');
    
    item.setAttribute('value', entries[i].eId);
    item.setAttribute('allowevents', true);
    if (entries[i].showif) item.setAttribute('conquery_flag', "showifSet");
    if (entries[i].blocked) item.setAttribute('style', "color: #828282");
		//item.setAttribute('ondblclick', ondk);
		
    celldata = document.createElement('listcell');
    celldata.setAttribute('label', entries[i].Title);
    celldata.setAttribute('ondblclick', ondk);
    item.appendChild(celldata);
    if (srcHash.Items == EntryHash.Items){
      hbx = document.createElement('hbox');
      hbx.setAttribute('align', "center");
      hbx.setAttribute('flex', "1");
      hbx.setAttribute('pack', "center");

      cellcheck = document.createElement('listcell');
      check = document.createElement('checkbox');
      check.setAttribute('id', entries[i].eId);
      check.setAttribute('oncommand', "UpdateStatus(this);");
      check.setAttribute('checked', entries[i].Context);
      hbx.appendChild(check);
      cellcheck.appendChild(hbx);
      item.appendChild(cellcheck);
//      if (entries[i].showif){
//        cellshowif = document.createElement('listcell');
//        cellshowif.setAttribute('label', "yes");
//        item.appendChild(cellshowif);
//      }
    }
    list.appendChild(item);
  }
}

function onSelect(){
	var desctext = "";
	if (!EntryList.selectedItem) return;
	eId = EntryList.selectedItem.getAttribute('value');
	if (!EntryHash.Items[eId].Inputs){
		var entry = plg_ReadData(EntryHash.Items[eId].filepath);
    entry.Context = EntryHash.Items[eId].Context;
    entry.lastmatch = EntryHash.Items[eId].lastmatch;
		EntryHash._AddEntryObj(entry);
	}
	item = EntryHash.Items[eId];
	desctext = item.Title + ":\n" +
  	item.Desc + "\n" +
  	item.filepath;
	if (item.showif) desctext += cqrMess.GetStringFromName('cqr.cfg.descrSI') + item.showif + " " + cqrMess.GetStringFromName('cqr.cfg.descrSIfound') + item.sitarget;
	desctext += cqrMess.GetStringFromName('cqr.cfg.descrInps') + "Action = " + item.Action + "\n";
  for (i in item.Inputs){
    desctext += i+" = "+item.Inputs[i].value +"\n";
    if (item.Inputs[i].list){
    	for (v in item.Inputs[i].list) desctext += " " + cqrMess.GetStringFromName('cqr.cfg.descrInpsOr') + " " + item.Inputs[i].list[v].value + "\n";
    }
  }
	EntryDesc.value = desctext;
}

function UpdateStatus(check){
  EntryHash.Items[check.id].Context = check.checked;
	prfs_SaveEntry(EntryHash.Items[check.id]);
}

function ExecQuery(ctrl, id){
try{
  window.opener.top.cqrConfigLastWillId = EntryList.selectedItem.getAttribute('value');
  window.opener.top.cqrConfigLastWillCtrl = ctrl;
  window.close();
}catch(er){cqerr(er, "ExecQuery sub")}
}


function isValidLeftClick(aEvent, aName){
  return (aEvent.button == 0 && aEvent.originalTarget.localName == aName);
}

function movePlug(unit){
  var entryId = null;
  unit = parseFloat(unit);
  
  if (!EntryList.selectedItem) return;
  entryId = EntryList.selectedItem.getAttribute('value');
  in_order = parseFloat(EntryHash.Items[entryId].order);
  o_src = parseFloat(EntryHash.Items[entryId].order);
  if (unit > 0){
    var nearestOrder = 1000000;
    var nearestItemId = "";
    for (each in EntryHash.Items){
      if (parseFloat(EntryHash.Items[each].order) < nearestOrder &&
          parseFloat(EntryHash.Items[each].order) >= parseFloat(EntryHash.Items[entryId].order) &&
          EntryHash.Items[each].eId != EntryHash.Items[entryId].eId){
        nearestOrder = parseFloat(EntryHash.Items[each].order);
        nearestItemId = EntryHash.Items[each].eId;
      }
    }
  }else if (unit < 0){
    var nearestOrder = 0;
    var nearestItemId = "";
    for (each in EntryHash.Items){
      if (parseFloat(EntryHash.Items[each].order) > nearestOrder &&
          parseFloat(EntryHash.Items[each].order) < parseFloat(EntryHash.Items[entryId].order) &&
          EntryHash.Items[each].eId != EntryHash.Items[entryId].eId){
        nearestOrder = parseFloat(EntryHash.Items[each].order);
        nearestItemId = EntryHash.Items[each].eId;
      }
    }
  }

  ind = EntryList.getIndexOfItem(EntryList.selectedItem);
  
  if (nearestOrder == 0 || nearestOrder == 1000000 || (ind + unit) > EntryList.getRowCount()){
    return;
  } else if (parseFloat(EntryHash.Items[entryId].order) == parseFloat(EntryHash.Items[nearestItemId].order)){
    EntryHash.Items[entryId].order = parseFloat(EntryHash.Items[nearestItemId].order) + unit;
  } else if (parseFloat(EntryHash.Items[entryId].order) != parseFloat(EntryHash.Items[nearestItemId].order)) {
    var tmp = EntryHash.Items[nearestItemId].order;
    EntryHash.Items[nearestItemId].order = EntryHash.Items[entryId].order;
    EntryHash.Items[entryId].order = tmp;
  }
  //XXX orderIndex hack:
  EntryHash.orderIndex[parseFloat(EntryHash.Items[entryId].order)] = entryId;
  EntryHash.orderIndex[parseFloat(EntryHash.Items[nearestItemId].order)] = nearestItemId;

  prfs_SaveEntry(EntryHash.Items[entryId]);
  prfs_SaveEntry(EntryHash.Items[nearestItemId]);

  i = EntryList.selectedItem;
  EntryList.removeChild(EntryList.selectedItem);

  if ((ind + unit) >= EntryList.getRowCount()){
    EntryList.appendChild(i);
  } else if ((ind + unit) < 1) {
    EntryList.insertBefore(i, EntryList.getItemAtIndex(0))
  } else {
    EntryList.insertBefore(i, EntryList.getItemAtIndex(ind + unit))
  }
  EntryList.selectedItem = i;
  EntryList.ensureIndexIsVisible(EntryList.getIndexOfItem(EntryList.selectedItem));
}

function getPlugsFolder(){
  var folderPicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(folderPicker);
  fp.init(window, "", folderPicker.modeGetFolder);
  var res = fp.show();
  if (res == folderPicker.returnOK) {
    document.getElementById('prfs_plugsdir').value = fp.file.path;
  }
}